
(** Helper functions for running spec tests *)

module type Examples = sig
  type t
  val examples : t list
end

(*
[checkN inputs name test] raises an exception if the test fails on any N-tuple of
inputs, and returns unit if the test succeeds.

Idiomatic usage:

  TEST_UNIT = check2 examples property
    if property takes two arguments, or

  TEST_UNIT = check3 examples property
    if property takes three arguments
*)

val check1 : 'a list -> ('a -> bool)             -> unit
val check2 : 'a list -> ('a -> 'a -> bool)       -> unit
val check3 : 'a list -> ('a -> 'a -> 'a -> bool) -> unit

